#include"coordinate.h"

Coordinate::Coordinate(long radEW = 0, long radNS = 0, int intHight = 0) {
	_radEW.setData(radEW);
	_radNS.setData(radNS);
	_intHight = intHight;
}

Coordinate::Coordinate(Radian radEW, Radian radNS, int intHight = 0) {
	_radEW = radEW;
	_radNS = radNS;
	_intHight = intHight;
}

void Coordinate::setRadNS(Radian radNS) {
	_radNS = radNS;
}

void Coordinate::setRadEW(Radian radEW) {
	_radEW = radEW;
}

void Coordinate::setIntHight(int intHight) {
	_intHight = intHight;
}

Radian Coordinate::getRadNS() {
	return _radNS;
}

Radian Coordinate::getRadEW() {
	return _radEW;
}

int Coordinate::getIntHight() {
	return _intHight;
}

QString Coordinate::toString() {
	return _radEW.toString() + "," + _radNS.toString() + "," + _intHight;
}

bool Coordinate::parse(const QString &str) {
	return false;
}

void Coordinate::convTokyoToWGS84() {
	Radian newEW, newNS;
	newEW.setData(_radEW.toLong() + 0.000046038 * (_radNS.toLong())
			- 0.000083043 * (_radEW.toLong()) + 6025);
	newNS.setData(_radNS.toLong() - 0.00010695 * (_radNS.toLong())
			- 0.000017464 * (_radEW.toLong()) - 2761);
	_radEW = newEW;
	_radNS = newNS;
}

void Coordinate::convWGS84ToTokyo() {
	Radian newEW, newNS;
	newEW.setData(_radEW.toLong() - 0.000046047 * (_radNS.toLong())
			+ 0.000083049 * (_radEW.toLong()) - 6025);
	newNS.setData(_radNS.toLong() + 0.00010696 * (_radNS.toLong())
			+ 0.000017467 * (_radEW.toLong()) + 2761);
	_radEW = newEW;
	_radNS = newNS;
}

Coordinate& Coordinate::operator=(Coordinate value) {
	_radEW = value.getRadEW();
	_radNS = value.getRadNS();
	_intHight = value.getIntHight();
	return *this;
}
